﻿Imports Microsoft.VisualBasic
#Region "Copyright Syncfusion Inc. 2001 - 2012"
' Copyright Syncfusion Inc. 2001 - 2012. All rights reserved.
' Use of this code is subject to the terms of our license.
' A copy of the current license can be obtained at any time by e-mailing
' licensing@syncfusion.com. Any infringement will be prosecuted under
' applicable laws. 
#End Region
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports Syncfusion.PivotAnalysis.Base
Imports Syncfusion.Windows.Forms.Grid
Imports Syncfusion.Windows.Forms
Imports DemoCommon.Grid

Namespace CellSelectionDemo
	Partial Public Class Form1
		Inherits GridDemoForm
		#region "Constructor"

		Public Sub New()
			InitializeComponent()
			Me.GridSettings()
		End Sub

		#End Region

		#region "GridSettings"

		''' <summary>
		''' Grid Settings for better look and feel
		''' </summary>
		Private Sub GridSettings()
            ' Adding ItemSource to the Control

            Dim file_name As String = Application.StartupPath & "\Transacties.xml"
            Dim Ds As New DataSet
            Dim Transacties As New DataTable

            Try
                Ds.ReadXml(file_name, XmlReadMode.ReadSchema)
                Transacties = Ds.Tables(0)


            Catch ex As Exception

            End Try


            Me.pivotGridControl1.ItemSource = Transacties

            With pivotGridControl1
                .ShowPivotTableFieldList = False
                .TableControl.FreezeHeaders = True
                .ShowCalculationsAsColumns = False

                .PivotRows.Add(New PivotItem With {.FieldMappingName = "GroepNaam", .TotalHeader = ""})
                .PivotRows.Add(New PivotItem With {.FieldMappingName = "RubriekNaam", .TotalHeader = ""})
                .PivotRows.Add(New PivotItem With {.FieldMappingName = "RekeningNaam", .TotalHeader = ""})

                .PivotColumns.Add(New PivotItem With {.FieldMappingName = "Jaar", .TotalHeader = ""})

                .PivotCalculations.Add(New PivotComputationInfo With {.FieldName = "Bedrag", .Format = "#,##0.00", .SummaryType = Syncfusion.PivotAnalysis.Base.SummaryType.DecimalTotalSum})
                .PivotCalculations.Add(New PivotComputationInfo With {.FieldName = "Nummer", .Format = "#,##0", .SummaryType = Syncfusion.PivotAnalysis.Base.SummaryType.IntTotalSum})
                '.PivotCalculations.Add(New PivotComputationInfo With {.FieldName = "Test1", .Format = "#,##0", .CalculationType = CalculationType.Formula, .Formula = "[Bedrag] * [Nummer]"})
                '.PivotCalculations.Add(New PivotComputationInfo With {.FieldName = "Test2", .Format = "#,##0", .CalculationType = CalculationType.Formula, .Formula = "[Bedrag] * 2"})


            End With

            'tab key navigation set as false to move the next control
            Me.pivotGridControl1.TableControl.WantTabKey = False
            Me.pivotGridControl1.ShowPivotTableFieldList = False
            Me.pivotGridControl1.AllowFiltering = True
            Me.pivotGridControl1.ShowGroupBar = False
            AddHandler Me.pivotGridControl1.Filters.CollectionChanged, AddressOf Filters_CollectionChanged
            AddHandler Me.pivotGridControl1.TableModel.QueryColWidth, AddressOf RbrPivot_QueryColWidth


        End Sub
		Private filterIndex As Integer = 0

        Private Sub Filters_CollectionChanged(ByVal sender As Object, ByVal e As System.Collections.Specialized.NotifyCollectionChangedEventArgs)
			If e.NewItems IsNot Nothing AndAlso TypeOf e.NewItems(0) Is FilterExpression Then
				Dim expression As FilterExpression = TryCast(e.NewItems(0), FilterExpression)
				Dim filteredvalue() As String = expression.Expression.Split(New String() { "||" }, StringSplitOptions.None)
				Dim values As String =Nothing
				For Each value As String In filteredvalue
					values &= value.Replace(expression.DimensionName, String.Empty).Replace("=", String.Empty)+ Constants.vbCrLf
				Next value
			End If
		End Sub

        Private Sub RbrPivot_QueryColWidth(sender As Object, e As Syncfusion.Windows.Forms.Grid.GridRowColSizeEventArgs)

            '** e.Index = col no -> 1e col = veld 1 etc...
            If e.Index > 0 And e.Index < Me.pivotGridControl1.PivotRows.Count + 1 Then

                Select Case Me.pivotGridControl1.PivotRows.Item(e.Index - 1).FieldMappingName

                    Case "GroepNaam"
                        e.Size = 150
                        e.Handled = True

                    Case "RubriekNaam"
                        e.Size = 250
                        e.Handled = True

                    Case "RekeningNaam"
                        e.Size = 100
                        e.Handled = True

                End Select

            End If

        End Sub


#End Region

#Region "DataSource"

        Public Class ProductSales
#Region "AA"

            Private privateProduct As String
			Public Property Product() As String
				Get
					Return privateProduct
				End Get
				Set(ByVal value As String)
					privateProduct = value
				End Set
			End Property

			Private privateDate As String
			Public Property [Date]() As String
				Get
					Return privateDate
				End Get
				Set(ByVal value As String)
					privateDate = value
				End Set
			End Property

			Private privateCountry As String
			Public Property Country() As String
				Get
					Return privateCountry
				End Get
				Set(ByVal value As String)
					privateCountry = value
				End Set
			End Property

			Private privateState As String
			Public Property State() As String
				Get
					Return privateState
				End Get
				Set(ByVal value As String)
					privateState = value
				End Set
			End Property

			Private privateQuantity As Integer
			Public Property Quantity() As Integer
				Get
					Return privateQuantity
				End Get
				Set(ByVal value As Integer)
					privateQuantity = value
				End Set
			End Property

			Private privateAmount As Double
			Public Property Amount() As Double
				Get
					Return privateAmount
				End Get
				Set(ByVal value As Double)
					privateAmount = value
				End Set
			End Property

			Private privateUnitPrice As Double
			Public Property UnitPrice() As Double
				Get
					Return privateUnitPrice
				End Get
				Set(ByVal value As Double)
					privateUnitPrice = value
				End Set
			End Property

			Private privateTotalPrice As Double
			Public Property TotalPrice() As Double
				Get
					Return privateTotalPrice
				End Get
				Set(ByVal value As Double)
					privateTotalPrice = value
				End Set
			End Property

			#End Region

			''' <summary>
			''' Generate a data for Data Source
			''' </summary>
			Public Shared Function GetSalesData() As ProductSalesCollection
				''' Geography
				Dim countries() As String = { "Australia", "Canada", "France", "Germany", "United Kingdom", "United States" }
				Dim ausStates() As String = { "New South Wales", "Queensland", "South Australia", "Tasmania", "Victoria" }
				Dim canadaStates() As String = { "Alberta", "British Columbia", "Brunswick", "Manitoba", "Ontario", "Quebec" }
				Dim franceStates() As String = { "Charente Maritime", "Essonne", "Garonne (Haute)", "Gers" }
				Dim germanyStates() As String = { "Bayern", "Brandenburg", "Hamburg", "Hessen", "Nordrhein Westfalen", "Saarland" }
				Dim ukStates() As String = { "England" }
				Dim ussStates() As String = { "New York", "North Carolina", "Alabama", "California", "Colorado", "New Mexico", "South Carolina" }

				''' Time
				Dim dates() As String = { "FY 2005", "FY 2006", "FY 2007", "FY 2008", "FY 2009" }

				''' Products
				Dim products() As String = { "Bike", "Car" }
				Dim r As New Random(123345345)

				Dim numberOfRecords As Integer = 2000
				Dim listOfProductSales As New ProductSalesCollection()
				For i As Integer = 0 To numberOfRecords - 1
					Dim sales As New ProductSales()
					sales.Country = countries(r.Next(1, countries.GetLength(0)))
					sales.Quantity = r.Next(1, 12)
					''' 1 percent discount for 1 quantity
					Dim discount As Double = (30000 * sales.Quantity) * (Double.Parse(sales.Quantity.ToString()) / 100)
					sales.Amount = (30000 * sales.Quantity) - discount
					sales.TotalPrice = sales.Amount * sales.Quantity
					sales.UnitPrice = sales.Amount / sales.Quantity
					sales.Date = dates(r.Next(r.Next(dates.GetLength(0) + 1)))
					sales.Product = products(r.Next(r.Next(products.GetLength(0) + 1)))
					Select Case sales.Country
						Case "Australia"
								sales.State = ausStates(r.Next(ausStates.GetLength(0)))
								Exit Select
						Case "Canada"
								sales.State = canadaStates(r.Next(canadaStates.GetLength(0)))
								Exit Select
						Case "France"
								sales.State = franceStates(r.Next(franceStates.GetLength(0)))
								Exit Select
						Case "Germany"
								sales.State = germanyStates(r.Next(germanyStates.GetLength(0)))
								Exit Select
						Case "United Kingdom"
								sales.State = ukStates(r.Next(ukStates.GetLength(0)))
								Exit Select
						Case "United States"
								sales.State = ussStates(r.Next(ussStates.GetLength(0)))
								Exit Select
					End Select
					listOfProductSales.Add(sales)
				Next i

				Return listOfProductSales
			End Function

			Public Overrides Function ToString() As String
				Return String.Format("{0}-{1}-{2}", Me.Country, Me.State, Me.Product)
			End Function

			Public Class ProductSalesCollection
				Inherits List(Of ProductSales)
			End Class
		End Class

		''' <summary>
		''' Set the ShowGroupBar
		''' </summary>
		Private Sub checkBox1_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs)
			Me.pivotGridControl1.ShowGroupBar = Not Me.pivotGridControl1.ShowGroupBar
		End Sub

        Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

            Me.pivotGridControl1.TableControl.CollapseAllRowGroups()


        End Sub

        Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click

            Me.pivotGridControl1.TableControl.ExpandAllRowGroups()


        End Sub

#End Region

    End Class
End Namespace
